<?php
/*
Plugin Name: Title Counter
Plugin URI: http://inspire-design.net/
Description: タイトルの文字数を自動的にカウントして表示します。
Author: Masayuki Ietomi <jyokyoku@gmail.com>
Version: 1.0
Author URI: http://inspire-tech.net/
*/

if ( version_compare( get_bloginfo( 'version' ), '3.5.0', '<' ) ) {
	exit;
}

function tc_add_html() {
	echo '<div class="str-count" data-for="post_title"></div>';
}

if ( version_compare( get_bloginfo( 'version' ), '4.4.1', '<' ) ) {
	add_action( 'edit_form_after_title', 'tc_add_html' );

} else {
	add_action( 'edit_form_before_permalink', 'tc_add_html' );
}

function tc_script_and_css() {
	?>
	<style type="text/css">
		.str-count {
			border: 1px solid #ddd;
			background: #f6f6f6;
			padding: 4px 8px;
			font-size: 12px;
		}
	</style>
	<?php
	if ( version_compare( get_bloginfo( 'version' ), '4.4.1', '>=' ) ) {
		?>
		<style type="text/css">
			.str-count {
				margin-top: -3px;
				margin-bottom: 5px;;
			}
		</style>
		<?php
	}
	?>
	<script type="text/javascript">
		(function ($) {
			$('.str-count').each(function () {
				if (!$(this).data('for')) {
					return false;
				}

				var $self = $(this),
					$for = $('[name="' + $(this).data('for') + '"]'),
					max = $(this).data('max') || 0;

				if ($for.length < 1) {
					return false;
				}

				$(document).on('blur keydown keyup', '[name="' + $(this).data('for') + '"]', function () {
					var count = $for.val().replace(/\r?\n/g, '').length,
						max_count = '';

					if (max) {
						max_count = ' (最大 ' + max + ' 文字)';
					}

					$self.text('文字数: ' + count + max_count);

					if (max && max < count) {
						$self.attr('style', 'color: red;');

					} else {
						$self.attr('style', '');
					}
				});

				$for.trigger('blur')
			});
		})(jQuery);
	</script>
	<?php
}

add_action( 'admin_print_footer_scripts', 'tc_script_and_css' );